variables:
  DOCKER_DRIVER: overlay
  DOCKER_HOST: tcp://docker:2375/

services:
  - docker:dind

stages:
  - test
  - push

test:
  stage: test
  image:
    name: docker/compose:1.23.2
    entrypoint: [""]
  script:
    - cd web
    - docker-compose run --rm node yarn install
    - docker-compose run --rm node yarn run htmllint-lint
  only:
    changes:
      - web/**/*
  except:
    - master
    - tags

push:
  stage: push
  image: docker:latest
  script:
    - apk add --update make ca-certificates openssl python
    - update-ca-certificates
    - wget https://dl.google.com/dl/cloudsdk/release/google-cloud-sdk.tar.gz
    - tar zxvf google-cloud-sdk.tar.gz && ./google-cloud-sdk/install.sh --usage-reporting=false --path-update=true
    - google-cloud-sdk/bin/gcloud --quiet components update
    - google-cloud-sdk/bin/gcloud auth configure-docker
    - docker login -u _json_key -p "$GCLOUD_SERVICE_KEY" https://gcr.io
    - cd web
    - docker build -t "gcr.io/$PROJECT_ID_PRODUCTION/devops-test:$CI_COMMIT_TAG" .
    - docker images
    - docker push "gcr.io/$PROJECT_ID_PRODUCTION/devops-test:$CI_COMMIT_TAG"
  only:
    - tags
